//数据对象
var data = {};
//参数对象
var param = {};

var lastClickedImagePosition = {
    top : 0,
    left : 0
};

/**
 * 初始化
 * 读取接口后调用此函数，
 * data_json 接口返回的json数据
 */
function init(data_json){
	//主题数据
	data = data_json;

	//当前页数
	param.page = 1;
	//栏目ID
	param.fid = data.data.thread.fid;
	//帖子ID
	param.tid = data.data.thread.tid;

	//填充模板
	fill();

	////加载视频图片
	//dzplayerThumb();

	//加载图片
	scrollLoad();



	//绑定事件
	addClicks();

	//返回回复部分距离顶部的高度
	return $('#posts_div').offset().top;

	//上拉、下拉
//	iscollLoaded();

//	myScroll.scrollToElement(document.querySelector('#post_79726160'));
}

//填充模板
function fill(){
	fillThread();
	fillPosts();
	
}
//填充帖子部分
function fillThread(){
	//只有第一页才加载帖子信息，后面的页，只加载回复
	if (param.page == 1)
	{
		//帖子信息
		var html = template('thread', data.data);
		document.getElementById('thread_div').innerHTML = html;
	}
}
//填充回复
function fillPosts(){
	//回复信息
	var html = template('posts', data.data);
	if (param.page == 1){
		$('#posts_div').html(html);
	}else{
		//先删除之前加载的本页回复
		$('#posts_div li.page'+ param.page).remove();
		$('#posts_div').append(html);
	}

	if (param.page < data.data.pages){
		$('#placeholder_70px').show();
	}else{
		$('#placeholder_70px').hide();
	}
}

var is_clicked_on = false;
function addClicks(){
	//单击事件响应
    if (! is_clicked_on){
        $('#content').on("click", 'span.no-phiz img', onImageClicked);
        $('#content').on("click", 'span.no-phiz', onShowImageAtIndex);
        $('#posts_div').on("click", '.toReply', onReplyClicked);
		$('#posts_div').on("click", '.toSupport', onSupportClicked);
        //	$('#more_btn').bind('touchend', function(){
        //		$('.btn2').toggle();
        //	});
		$('#content').on("click", '.dzplayer_play', onDzplayerClicked);
        $('#content').on("click", '.author_cls', onPhotoClicked);
        $('#posts_div').on("click", '.pre_author', onPhotoClicked);
        is_clicked_on = true;
    }
	if (! (data.data.thread.recommend == 'add' || data.data.thread.recommend == 'subtract')){
		$('.up').click(onRecommendAddClicked);
//		$('.down').click(onRecommendSubClicked);
	}
	$('.only').click(onOnlyAuthorClicked);
	$('.reverse').click(onOrdertypeClicked);
	$('.report').click(onReportClicked);
	
}
//点赞回调，客户端获取最新的点赞数
function onRecommendAddClickedCallback(num) {
	$('#recommendAdd').html(num);
	$('.up img').attr('src', 'images/btn1_on.png');
	unbindRecommendClick();
}

//踩回调，客户端获取最新的踩数
function onRecommendSubClickedCallback(num) {
	$('#recommendSub').html(num);
	$('.down img').attr('src', 'images/btn2_on.png');
	unbindRecommendClick();
}
//解除顶踩的事件
function unbindRecommendClick(){
	$('.up').unbind('click');
	$('.down').unbind('click');
}

//客户端获取到图片之后，回调此函数
function changeImgSrc(id,src){
	var obj = document.getElementById(id);
	DZ.log(id+obj);
	document.getElementById(id).setAttribute("src", src);
	document.getElementById(id).setAttribute("loaded", 1);
}
//下一页回调函数，客户端使用
function nextPageCallback(data_json){
	//当前页码
	if (data_json.data.param.page != param.page)
	{
		param.page = data_json.data.param.page;
	}

	//主题数据
	data = data_json;

	//填充模板
	fill();

	//加载图片
	scrollLoad();
	
//	iscollLoaded('refresh', param.page);
	
}

//楼层
template.helper('floor', function (number){
	var str = '';
	switch(number){
		case '2': str = '沙发';break;
		case '3': str = '板凳';break;
		case '4': str = '地板';break;
		default: str = number+ '楼';break;
	}
	return str;
});

//格式化页数
var parsePage = function(page){
	page = parseInt(page);
	if (isNaN(page) || page < 1)
	{
		page = 1;
	}
	return page;
};

function getElementViewLeft(element) {
    var actualLeft = element.offsetLeft;
    var current = element.offsetParent;
    while (current !== null) {
        actualLeft += current.offsetLeft;
        current = current.offsetParent;
    }
    if (document.compatMode == "BackCompat") {
        var elementScrollLeft = document.body.scrollLeft;
    } else {
        var elementScrollLeft = document.documentElement.scrollLeft;
    }
    return actualLeft - elementScrollLeft;
}

function getElementViewTop(element) {
    var actualTop = element.offsetTop;
    var current = element.offsetParent;
    while (current !== null) {
        actualTop += current.offsetTop;
        current = current.offsetParent;
    }
    if (document.compatMode == "BackCompat") {
        var elementScrollTop = document.body.scrollTop;
    } else {
        var elementScrollTop = document.documentElement.scrollTop;
    }
    return actualTop - elementScrollTop;
}
function showMapNoticeInfo(index, msg) {
    var noticeDiv = jQuery('#mapNoticeInfo_'+ index)[0];
    $(noticeDiv).css('display', 'block');
    var spanTag = $(noticeDiv).find('span')[0];
    spanTag.innerHTML = msg;
}

function getElementLeft(element) {
    var actualLeft = element.offsetLeft;
    var current = element.offsetParent;
    while (current !== null) {
        actualLeft += current.offsetLeft;
        current = current.offsetParent;

    }
    return actualLeft;
}

function getElementTop(element) {
    var actualTop = element.offsetTop;
    var current = element.offsetParent;
    while (current !== null) {
        actualTop += current.offsetTop;
        current = current.offsetParent;
    }
    return actualTop;
}

// 调整正文字体大小，由小到大分为1-4级
function changeFont(fontSize) {
    if (fontSize < 1 || fontSize > 4){
         return;
    }
    var contentDiv = document.getElementById('content');
    contentDiv.className = 'fontSize' + fontSize;
}

//回复点赞回调，更新点赞数量等
//had_supported：是否已点赞，0表示未点赞，1表示已点赞
function onSupportClickedCallback(pid, had_supported){
	$('#support_'+ pid).attr('is_supported', 1);
	$('img', '#support_'+ pid).attr('src', 'images/reply_support_new_on.png');


    var support_nums = $('#support_nums_'+ pid).html();
    if(support_nums.length==0){
        support_nums = "1";
	}
    support_nums = parseInt(support_nums);
    $('#support_nums_'+ pid).html(support_nums+1);
    $('#support_nums_'+ pid).css('display', 'inline');
	if (had_supported == 0)
	{

	}
}