//数据对象
var data = {};
//参数对象
var param = {};

var lastClickedImagePosition = {
    top : 0,
    left : 0
};

var vindex, video, vplay, vcover, imgnum=0, imgchangenum=0;

/**
 * 初始化
 * 读取接口后调用此函数，
 * data_json 接口返回的json数据
 */
function init(data_json){
	//主题数据
	data = data_json;
	// data = JSON.parse(data_json);

    // 新闻ID
    param.nid = data.variable.id;

    // 新闻ID
    param.cid = data.variable.cid;
    DZ.log("  cid");
    // good & bad
    param.good = parseInt(data.variable.remark.good);
    param.bad = parseInt(data.variable.remark.bad);

	//填充模板
	fill();

    setAudioHeight('90px');

	//加载图片
    // scrollLoad();
    imageLoad(); 

	//绑定事件
	addClicks();



}

// 监听Dom加载完成
document.addEventListener("DOMContentLoaded", function(event) {
  DZ.log("DOM fully loaded and parsed");
});

//填充模板
function fill(){
	fillThread();
    // fillPosts();
}
//填充内容部分
function fillThread(){
	
	// 详情
	var val = data.variable;
	
    val['content'] = val['html'];
	

    var video;
    if (val['video'].length === 0) {
        video = val['video'];
    }else if(val['videos'] && val['videos'].length === 0){
        video = val['videos'][0];
    }else{
        video = '';
    }
	var html = template('thread', val);
	document.getElementById('thread_div').innerHTML = html;


    // DZ.initFinish();

}

// 填充热门新闻列表部分
function fillPosts(){
    // 热门新闻
    var val = data.variable;

    var html = template('posts', val);
    $('#posts_div').html(html);
}


var is_clicked_on = false;
function addClicks(){
	//单击事件响应
    if (! is_clicked_on){

         var self = this;
         var longClick =0;
         $(".a-image img").on({
             touchstart: function(e){
                 longClick=0;//设置初始为0
                 timeOutEvent = setTimeout(function(){
                     //此处为长按事件-
                     onImageLongClick(e);
                     longClick=1;//假如长按，则设置为1
                 },500);
             },
             touchmove: function(){
                 clearTimeout(timeOutEvent);
                 timeOutEvent = 0;
                 e.preventDefault();
             },
             touchend: function(e){
                 clearTimeout(timeOutEvent);
                 if(timeOutEvent!=0 && longClick==0){//点击
                     //此处为点击事件-
                     onImageClicked(e);
                 }
                 return false;
             }
         });




//        $('#js-content').on("click", '.a-image img', onImageClicked);
        // 播放视频
        $('#js-article').on("click", '.video-wrapper .video .video-play', onVideoClicked);
        // 详情页中有多视频，视频播放
        $('#js-article').on("click", '.video-wrapper .video .video-play-web', function(event){
            vindex = event.target.getAttribute("video-index");
            video = '#video'+vindex;
            vplay = '#vplay'+vindex;
            vcover = '#vcover'+vindex;
            idvideo = 'video'+vindex;
            
            $(vplay).hide();
            $(vcover).hide();
            $('video').trigger('pause');
            $(video).show().trigger('play');
            
            // // 计算视频位置
            // var vcd = document.getElementById(idvideo);
            // var vcdFrame = {
            //     index : vindex,
            //     top : getElementTop(vcd),
            //     left : getElementLeft(vcd),
            //     width : vcd.clientWidth,
            //     height : vcd.clientHeight,
            //     video_url: $(this).parent().attr('video_url'),
            //     bgimg: $(vcover).css('background-image').replace('url("','').replace('")','')
            // };
            // onVcdClicked(vcdFrame);

        });

        // 相关新闻按压效果
        $('#posts_div').on("touchstart", '.recommend ', onRecommendTouchStart);
        $('#posts_div').on("click", '.recommend ', onRecommendClicked);
        $('#posts_div').on("touchend", '.recommend ', onRecommendTouchEnd);
        $('#posts_div').on("touchcancel", '.recommend ', onRecommendTouchcancel);
    }
	
    if (! (data.variable.remark.remark == 'good' || data.variable.remark.remark == 'bad')){
        $('.up').click(onDZGoodClicked);
        $('.down').click(onDZBadClicked);
    }
}


//客户端获取到图片之后，回调此函数
function changeImgSrc(id,src,layer){
    imgchangenum++;
    if (layer > 0) {
        document.getElementById(id).firstChild.firstChild.setAttribute("src", src);
    }else{
        document.getElementById(id).firstChild.setAttribute("src", src);
    }
	
    document.getElementById(id).setAttribute("loaded", 1);
    if (imgnum == imgchangenum) {
        DZ.log("imgnum="+imgnum);
        DZ.log("imgchangenum="+imgchangenum);
        //加载视频
        var timer1=window.setTimeout(function(){
            videoLoad();
            // 加载音频
            audioLoad();
            window.clearTimeout(timer1);
        },200);

    }
}

function getElementViewLeft(element) {
    var actualLeft = element.offsetLeft;
    var current = element.offsetParent;
    while (current !== null) {
        actualLeft += current.offsetLeft;
        current = current.offsetParent;
    }
    if (document.compatMode == "BackCompat") {
        var elementScrollLeft = document.body.scrollLeft;
    } else {
        var elementScrollLeft = document.documentElement.scrollLeft;
    }
    return actualLeft - elementScrollLeft;
}

function getElementViewTop(element) {
    var actualTop = element.offsetTop;
    var current = element.offsetParent;
    while (current !== null) {
        actualTop += current.offsetTop;
        current = current.offsetParent;
    }
    if (document.compatMode == "BackCompat") {
        var elementScrollTop = document.body.scrollTop;
    } else {
        var elementScrollTop = document.documentElement.scrollTop;
    }
    return actualTop - elementScrollTop;
}


function getElementLeft(element) {
    var actualLeft = element.offsetLeft;
    var current = element.offsetParent;
    while (current !== null) {
        actualLeft += current.offsetLeft;
        current = current.offsetParent;

    }
    return actualLeft;
}

function getElementTop(element) {
    var actualTop = element.offsetTop;
    var current = element.offsetParent;
    while (current !== null) {
        actualTop += current.offsetTop;
        current = current.offsetParent;
    }
    return actualTop;
}

// 调整正文字体大小，由小到大分为1-4级
function changeFont(fontSize) {
    if (fontSize < 1 || fontSize > 4){
         return;
    }
    var contentDiv = document.getElementById('js-content');
    contentDiv.className = 'content fontSize' + fontSize;
}
